<template>
  <b-row h-100 class="mb-2">
    <b-col cols="12" class="my-4 text-center">
      <span style="font-size: 24px">{{ title }}</span>
    </b-col>
    <loading-overlay :isVisible="isLoading"></loading-overlay>
    <b-col cols="4" class="mb-4" v-for="row in tcolumns" v-if="row.variation && row.variation.var_name && row.variation.material" :key="row.id">
      <b-card img-src="https://images.pexels.com/photos/459793/pexels-photo-459793.jpeg?auto=compress&cs=tinysrgb&h=650&w=940"
              img-alt="Image"
              img-top
              tag="article"
              class="mb-2">
        <p class="card-text">Nume produs: {{ row.variation.material.name }}</p>
        <p class="card-text">Nume variație produs: {{ row.variation.var_name.name }}</p>
        <p class="card-text">ID produs: {{ row.id }}</p>
        <p class="card-text">Cantitate produs: {{ row.quantity }} <span v-if="!row.variation.um">{{ row.variation.material.um }}</span><span v-else>{{ row.variation.um }}</span></p>
        <p class="card-text">Cantitate produs dupa tranzactie: {{ row.after_transaction }} <span v-if="!row.variation.um">{{ row.variation.material.um }}</span><span v-else>{{ row.variation.um }}</span></p>
        <b-button to="test/:id" variant="primary">View product</b-button>
      </b-card>
    </b-col>
  </b-row>
</template>

<script>
  import MaterialAPI from '@/api/MaterialAPI'
  import LoadingOverlay from '@/components/LoadingOverlay'

  export default {
    name: 'test-table',
    components: {
      LoadingOverlay
    },
    props: {
      title: {
        type: String,
        default: 'Materiale adaugate test'
      },
      newMaterialAdded: {
        type: Object,
        default: null
      }
    },
    data () {
      return {
        rows: [],
        isLoading: false
      }
    },
    computed: {
      tcolumns () {
        return this.rows
      }
    },
    methods: {
      refreshAddList () {
        let $this = this
        this.isLoading = true
        API.makeAsyncCall(MaterialAPI.getAddedMaterials + '9', {}, 'GET')
          .then(response => {
            console.log(response)
            $this.rows = response
            $this.isLoading = false
          })
          .catch(err => {
            console.log(err)
            $this.isLoading = false
          })
      }
    },
    watch: {
      newMaterialAdded (value) {
        if (value) {
          this.refreshAddList()
        }
      }
    },
    mounted () {
      let $this = this
      $this.isLoading = true
      $this.refreshAddList()
    },
    beforeDestroy () {
      axios.cancelAll('component destroyed')
    }
  }
</script>
